From 7ac98fa9726adfb051fda2822c04ebc7e4892d16 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Sep 02 2020 04:18:16 +0000
Subject: [PATCH 798/2232] Introduce newtype for target dir


I plan to cache the target dir determination, which will require passing
it around somewhat more in function arguments. Having a unique type will
make that less error prone.

---

diff --git a/gen/build/src/cargo.rs b/gen/build/src/cargo.rs
index 91f229d..3bddc6e 100644
--- a/gen/build/src/cargo.rs
+++ b/gen/build/src/cargo.rs
@@ -1,9 +1,10 @@
 use crate::error::TargetDirError;
+use crate::paths::TargetDir;
 use std::path::PathBuf;
 use std::process::Command;
 use std::str;
 
-pub(crate) fn target_dir() -> Result<PathBuf, TargetDirError> {
+pub(crate) fn target_dir() -> Result<TargetDir, TargetDirError> {
     let cargo = option_env!("CARGO").unwrap_or("cargo");
     let output = Command::new(cargo)
         .arg("metadata")
@@ -24,7 +25,7 @@ pub(crate) fn target_dir() -> Result<PathBuf, TargetDirError> {
         let close_quote_index = metadata.find('"')?;
         let string = &metadata[..close_quote_index];
         let target_directory = string.replace("\\\\", "\\");
-        Some(PathBuf::from(target_directory))
+        Some(TargetDir(PathBuf::from(target_directory)))
     })()
     .ok_or(TargetDirError::NotFound)
 }
diff --git a/gen/build/src/paths.rs b/gen/build/src/paths.rs
index c554ef0..e6b29bd 100644
--- a/gen/build/src/paths.rs
+++ b/gen/build/src/paths.rs
@@ -2,8 +2,18 @@ use crate::cargo;
 use crate::error::{Error, Result};
 use crate::gen::fs;
 use std::env;
+use std::ops::Deref;
 use std::path::{Path, PathBuf};
 
+pub(crate) struct TargetDir(pub PathBuf);
+
+impl Deref for TargetDir {
+    type Target = Path;
+    fn deref(&self) -> &Self::Target {
+        &self.0
+    }
+}
+
 fn out_dir() -> Result<PathBuf> {
     env::var_os("OUT_DIR")
         .map(PathBuf::from)
@@ -72,7 +82,7 @@ pub(crate) fn include_dir() -> Result<PathBuf> {
     Ok(target_dir.join("cxxbridge"))
 }
 
-fn target_dir() -> Result<PathBuf> {
+fn target_dir() -> Result<TargetDir> {
     let fallback_err = match cargo::target_dir() {
         Ok(target_dir) => return Ok(target_dir),
         Err(err) => Error::TargetDir(err),
@@ -82,7 +92,7 @@ fn target_dir() -> Result<PathBuf> {
     let mut dir = out_dir().and_then(canonicalize)?;
     loop {
         if dir.ends_with("target") {
-            return Ok(dir);
+            return Ok(TargetDir(dir));
         }
         if !dir.pop() {
             return Err(fallback_err);

